From 90867d80a081de1509dc57938e39ed02649f88ab Mon Sep 17 00:00:00 2001
From: Maxim Orlov <orlovmg@gmail.com>
Date: Tue, 18 Jun 2024 17:17:06 +0300
Subject: [PATCH v2] Invalidate xmax if HEAP_XMAX_INVALID is set.

---
 src/backend/access/heap/heapam.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 82bb9cb33b6..0c4db5b225f 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -6216,6 +6216,7 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 	Assert(t_infomask & HEAP_XMAX_IS_MULTI);
 
 	if (!MultiXactIdIsValid(multi) ||
+		(t_infomask & HEAP_XMAX_INVALID) ||
 		HEAP_LOCKED_UPGRADED(t_infomask))
 	{
 		*flags |= FRM_INVALIDATE_XMAX;
-- 
2.45.2

